力扣-三数之和

1.题目描述

2.题目链接

LCR 007. 三数之和 - 力扣(LeetCode)

3.题目代码

java 复制代码
import java.util.*;
class Solution {
    public List<List<Integer>> threeSum(int[] nums) {
        Arrays.sort(nums);
        int temp=nums.length-1;
        Set<List<Integer>> set=new HashSet<>();
        while(temp>1){
            int left=0,right=temp-1;
            while(left<right){
                if(nums[left]+nums[right]+nums[temp]==0){
                    List<Integer> row=Arrays.asList(nums[left],nums[right],nums[temp]);
                    set.add(row);
                    left++;right--;
                }
                else if(nums[left]+nums[right]+nums[temp]>0){
                    right--;
                }else{
                    left++;
                }
            }
            temp--;
        }
        return new ArrayList<>(set);
    }
}

4.解题思路

这道题我们用的依然还是双指针+定数指针的解题思路,和前面我记录的有效三角形的个数的OJ题目一样,只需要定义定数指针在数组的最后一个元素上,再在剩余数组的边界定义两个指针,根据单调性来进行指针的移动即可。

5.代码细节

1)类型转换

因为我们为了方便去重,定义的是set,而题目中的泛型要求我们返回List<List<Integer>>,所以我们在定义完set之后:

java 复制代码
 Set<List<Integer>> set = new HashSet<>();

还需要在最后转换类型:

java 复制代码
 return new ArrayList<>(set);

2)构造动态三元组

创建动态列表存储三元组:

java 复制代码
List<Integer> row=Arrays.asList(nums[left],nums[right],nums[temp]);

3)找到三元组后的指针移动逻辑

在找到1个三元组并且存入set后,我们需要移动双指针:left--,right++。

为什么呢?

因为我们需要寻找下一个符合条件的三元组,也就是寻找下一个满足numsleft+numsright+numstemp==0的三元组,但是如果移动单个指针 ,等式的平衡会被打破 ,左边一定不会等于右边 ,只有同时移动双指针,才有可能重新满足不等式。

相关推荐
UIU1149 小时前
P1233 [ICPC 2001 Taejon R] 木棍加工
数据结构·c++·算法·动态规划
论文复现现场9 小时前
WRF、FEA 能用 L40S 加速吗?求解器检查、断点恢复与长期运行
java·数据库·算法·wrf·有限元分析·gpu计算·断点续算
ZhengEnCi9 小时前
用 AI 写代码为什么拼到最后还是拼人:算力瓶颈与领域专家提示词的本质差异
算法·架构
秋天的怀念_David10 小时前
第二十一夜 · 数字黑洞与西西弗斯的惩罚
java·程序人生·算法
碧海银沙音频科技研究院11 小时前
在PC电脑上用Whisper→Marian算法实现离线语音翻译功能
算法·whisper
niyongsheng11 小时前
3D 装箱算法工程化:数据结构、放置启发式与支撑规则
数据结构·算法·rust
叉烧滑蛋13 小时前
B站台湾大学郭彦甫|MATLAB 学习笔记|04 变量与档案存取
数据结构
j7~14 小时前
【穷举、深搜与回溯算法】一棵决策树讲透全排列与子集
数据结构·c++·算法·leetcode·回溯·递归
傅科摆 _ py15 小时前
DP,贪心,堆和栈,二分力扣复习
开发语言·python·算法
Shaoshing15 小时前
LeetCode100 42.接雨水
java·算法·leetcode